#ifndef EDITACCOUNTDIALOGBASE_H
#define EDITACCOUNTDIALOGBASE_H

#include <qvariant.h>
#include <qdialog.h>
class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QButtonGroup;
class QCheckBox;
class QGroupBox;
class QLabel;
class QLineEdit;
class QPushButton;
class QRadioButton;
class QSlider;
class QTabWidget;
class QWidget;

class EditAccountDialogBase : public QDialog
{
    Q_OBJECT

public:
    EditAccountDialogBase( QString type, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~EditAccountDialogBase();

    QPushButton* cancelButton;
    QPushButton* okButton;
    QTabWidget* TabWidget2;
    QWidget* tab;
    QLabel* TextLabel1;
    QLabel* TextLabel2;
    QLabel* TextLabel3;
    QLineEdit* portEdit;
    QCheckBox* passCheck;
    QLabel* TextLabel5;
    QLabel* TextLabel4;
    QLabel* TextLabel3_2;
    QLineEdit* serverEdit;
    QLineEdit* accountEdit;
    QLineEdit* loginEdit;
    QLineEdit* userEdit;
    QLineEdit* passEdit;
    QWidget* tab_2;
    QLabel* TextLabel6;
    QLabel* TextLabel8;
    QLabel* TextLabel9;
    QLineEdit* smtpServerEdit;
    QLineEdit* fromEdit;
    QLineEdit* replyToEdit;
    QLabel* TextLabel7;
    QLineEdit* smtpPortEdit;
    QWidget* tab_3;
    QGroupBox* GroupBox1;
    QLabel* TextLabel10;
    QSlider* speedSlider;
    QLabel* TextLabel12;
    QLabel* TextLabel11;
    QLineEdit* maxEdit;
    QLabel* TextLabel14;
    QButtonGroup* maxActionGroup;
    QRadioButton* RadioButton1;
    QRadioButton* RadioButton2;
    QRadioButton* RadioButton3;
    QCheckBox* syncCheck;
    QCheckBox* leaveCheck;
    QCheckBox* sortCheck;

public slots:
    virtual void cancelClicked();
    virtual void fromChanged(const QString &);
    virtual void leaveClicked();
    virtual void maxEditChanged(const QString &);
    virtual void maxGroupChanged(int);
    virtual void nameChanged(const QString &);
    virtual void loginChanged(const QString &);
    virtual void okClicked();
    virtual void passChanged(const QString &);
    virtual void passClicked();
    virtual void portChanged(const QString &);
    virtual void serverChanged(const QString &);
    virtual void replyToChanged(const QString &);
    virtual void smtpPortChanged(const QString &);
    virtual void smtpServerChanged(const QString &);
    virtual void sortClicked();
    virtual void speedChanged(int);
    virtual void syncClicked();
    virtual void userChanged(const QString &);

protected:
    QGridLayout* EditAccountDialogBaseLayout;
    QGridLayout* tabLayout;
    QGridLayout* tabLayout_2;
    QGridLayout* tabLayout_3;
    QGridLayout* GroupBox1Layout;
    QHBoxLayout* maxActionGroupLayout;
    QString accountType;
};

#endif // EDITACCOUNTDIALOGBASE_H

