/*
 * This file is part of Magellan <http://www.kAlliance.org/Magellan>
 *
 * Copyright (c) 1998-2000 Teodor Mihai <teddy@ireland.com>
 * Copyright (c) 1998-2000 Laur Ivan <laur.ivan@ul.ie>
 * Copyright (c) 1999-2000 Virgil Palanciuc <vv@ulise.cs.pub.ro>
 *
 * Requires the Qt widget libraries, available at no cost at
 * http://www.troll.no/
 *
 * Also requires the KDE libraries, available at no cost at
 * http://www.kde.org/
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
 * IN THE SOFTWARE.
 */

#ifndef __Has_CardDialog__
#define __Has_CardDialog__

#include <kmainwindow.h>
#include <contactobj.h>
#include <carddialogwidget.h>
#include <cardtileview.h>

class EToolBarButton;

class CardDialog : public KMainWindow
{
	Q_OBJECT
	public:
		CardDialog(ContactObject *contact, QWidget *parent=0, bool *saved=0, const char *name=0);
		~CardDialog();
		void setCaption(QString, bool modified=false);
		void setTile(CardTileView *);
		void setFields(QStringList *);
		void setNewCard(bool);
		
		CardTileView *tile();
		QStringList *fields();
		bool newCard();
	private:
		void setMenu();
		void setToolbar();
		void initToolBar();
	public slots:
		void setNewHeight(int);
	signals:
		void dialogClosed(QString);
	private:
		CardDialogWidget *dialogWidget;
		bool _modified;
		QString _str;
		CardTileView *_tile;
		QStringList *_fields;
		bool _newCard;
	// the buttons
	public:
		EToolBarButton *upArrowButton;
		EToolBarButton *downArrowButton;
		EToolBarButton *saveButton;
		EToolBarButton *clearButton;
		EToolBarButton *helpButton;
		EToolBarButton *printButton;
		EToolBarButton *sendMailButton;
		EToolBarButton *addToGroupButton;
		
};
#endif
