/*
 * This file is part of Magellan <http://www.kAlliance.org/Magellan>
 *
 * Copyright (c) 1998-2000 Teodor Mihai <teddy@ireland.com>
 * Copyright (c) 1998-2000 Laur Ivan <laur.ivan@ul.ie>
 * Copyright (c) 1999-2000 Virgil Palanciuc <vv@ulise.cs.pub.ro>
 *
 * Requires the Qt widget libraries, available at no cost at
 * http://www.troll.no/
 *
 * Also requires the KDE libraries, available at no cost at
 * http://www.kde.org/
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
 * IN THE SOFTWARE.
 */

#ifndef __FolderTreeItem__
#define __FolderTreeItem__

#include <qlistview.h>
#include <templateview.h>
#include <qfileinfo.h>

class FolderTree;
class VFolder;
class VFolderAttribute;

class FolderTreeItem : public QListViewItem, public TemplateView
{
  public:
    FolderTreeItem(FolderTree *parent, VFolder *folder);
  	FolderTreeItem(FolderTreeItem *parent, VFolder *folder);
    ~FolderTreeItem();
    
    void update();
		
		QString getVFolderPath(void);
		QString getFilePath();
		void setFilePath(QString);
		
		bool isTypeAccepted(QString);
  private:
 		void paintBranches(QPainter *p, const QColorGroup &cg, int w, int y, int h, GUIStyle s);
		void paintCell(QPainter * p, const QColorGroup & cg, int column, int width, int align);
		void paintFocus(QPainter *p, const QColorGroup &cg, const QRect &r);
		int width(const QFontMetrics& fm, const QListView* lv, int c) const;
		int itemWidth(const QFontMetrics& fm, const QListView* lv, int c) const;
		
    int tag;
		VFolderAttribute *attr;
		QString fsPath;
		QString m_vfolderPath;
		QString acceptedTypes;
};

#endif
