/*
 * This file is part of Magellan <http://www.kAlliance.org/Magellan>
 *
 * Copyright (c) 1998-2000 Teodor Mihai <teddy@ireland.com>
 * Copyright (c) 1998-2000 Laur Ivan <laur.ivan@ul.ie>
 * Copyright (c) 1999-2000 Virgil Palanciuc <vv@ulise.cs.pub.ro>
 *
 * Requires the Qt widget libraries, available at no cost at
 * http://www.troll.no/
 *
 * Also requires the KDE libraries, available at no cost at
 * http://www.kde.org/
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
 * IN THE SOFTWARE.
 */

#ifndef __GroupTileWidget__
#define __GroupTileWidget__

#include <qstringlist.h>
#include <qlabel.h>
#include <grouptileview.h>
#include <groupobj.h>
#include <qfont.h>
#include <tilewidget.h>
#include <templateview.h>
#include <textfitter.h>

class GroupTileWidget : public TileWidget, public TemplateView, public TextFitter
{
	Q_OBJECT
	friend void fit_text(QString &srctext, QString &desttext, int size, QFont &font);
	public:
			GroupTileWidget(GroupTileView *parent, GroupObject *item, const char *name=0, const char *fname=0);
			~GroupTileWidget();
			QString key(int number);
			int keyCount();
			QString keyName(int number);
			void setTitle(const char *t);
			void setIcon(const QString &c);
			void deleteData();
			GroupObject *group();
			QWidget* localParent();
	public slots:
			void setState(ViewState);
			void open();
			void update();

			void removeDialog(QString);
	private:
			QLabel *npix;
			QLabel *ntxt;
			QWidget *_localParent;
	public:
		QWidget *dialogGroupQuery(QString);
		static void addGroupDialog(QString, QWidget *);
		static void removeGroupDialog(QString);
	private:
		static QDict<QWidget> groupEditDialogs;
};

#endif
