/*
 * This file is part of Magellan <http://www.kAlliance.org/Magellan>
 *
 * $Id: tilewidget.cpp,v 1.2 2001/05/19 10:53:18 alex Exp $
 *
 * Copyright (c) 1998-2000 Teodor Mihai <teddy@ireland.com>
 * Copyright (c) 1998-2000 Laur Ivan <laur.ivan@ul.ie>
 * Copyright (c) 1999-2000 Virgil Palanciuc <vv@ulise.cs.pub.ro>
 *
 * Requires the Qt widget libraries, available at no cost at
 * http://www.troll.no/
 *
 * Also requires the KDE libraries, available at no cost at
 * http://www.kde.org/
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
 * IN THE SOFTWARE.
 */

#include <clipboard.h>
#include <pixmaps.h>
#include <sortingwidget.h>
#include <tilewidget.h>
#include <mailer.h>

#include <qapplication.h>
#include <qclipboard.h>
#include <qcursor.h>

TileWidget::TileWidget(SortingWidget *parent, const char *name):QFrame(parent->viewport(), name), DataWidget(parent)
{
	int w, h;
  parent->getChildDimensions(w, h);
  setBackgroundColor(QColor("yellow"));
  
  if(parent->childFixedHeight())
  	setFixedSize(w, h);
  else
    setFixedWidth(w);
}

TileWidget::~TileWidget()
{
}

int TileWidget::keyCount()
{
	return 0;
}

QString TileWidget::key(int)
{
	return QString::null;
}

QString TileWidget::keyName(int)
{
	return QString::null;
}
